# АннотацияВыключенЕсли

## ПриСозданииОбъекта

```bsl
// Аннотация определяет что тест будет выключен в случае если переданное выражение вернет `Истина`
//
// Параметры:
//  Значение - Строка - [Лямбда-выражение](https://github.com/oscript-library/lambdas) без параметров, которое
//   должно вернуть `Булево`, `Истина` - тест будет пропущен, `Ложь` - тест будет выполнен, лямбда захватывает
//   объект тестового набора, так что ему доступны публичные\приватные поля объекта а так же экспортные методы
//  Причина  - Строка - Причина почему тест пропущен, которая будет указана в отчете о тестировании
//
// Пример:
//  1.
//  // Выключен всегда
//  //
//  &Тест
//  &ВыключенЕсли("() -> Истина", "Я никогда не буду выполнен")
//  Процедура Тест() Экспорт
//   
//  2.
//  // Включен всегда
//  //
//  &Тест
//  &ВыключенЕсли("() -> Ложь")
//  Процедура Тест() Экспорт
//   
//  3.
//  // Выключен если сегодня среда
//  //
//  &Тест
//  &ВыключенЕсли("() -> ДеньНедели(ТекущаяДата()) = 3", "It's wednesday, my dudes")
//  Процедура Тест() Экспорт
//   
//  4.
//  // МойТестовыйСценарий.os
//  //
//  Перем Поле;
//   
//  // Проверка поля сценария
//  //
//  &Тест
//  &ВыключенЕсли("() -> Поле", "В поле сценария была истина")
//  Процедура Тест() Экспорт
//   
//  5.
//  // МойТестовыйСценарий.os
//  //
//   
//  // Проверка метода сценария
//  //
//  &Тест
//  &ВыключенЕсли("() -> ПропуститьТест()", "Метод ПропуститьТест вернул истина")
//  Процедура Тест() Экспорт
//  КонецПроцедуры
//   
//  Функция ПропуститьТест() Экспорт
//      Возврат Истина;
//  КонецФункции
//
Процедура ПриСозданииОбъекта(Значение, Причина = "Условие переданное в ВыключенЕсли вернуло Истина") 
```
