// Аннотация определяет что метод является параметризованным тестом. 
// Метод может иметь параметры, так же должна быть ещё хотя бы одна аннотация, 
// которая является источником значений параметров:
//   * ИсточникВыражение
//   * ИсточникЗначение
//   * ИсточникНеопределено
//   * ИсточникПеречисление
//   * ИсточникJSON
//
// Параметры:
//  Имя - Строка - Шаблон имени теста для каждого набора значений параметров.
//    Может содержать автоматически заменяемые шаблоны:
//     `{ОтображаемоеИмя}` - По правилам аннотации `&ОтображаемоеИмя`
//     `{Параметры}` - Представление значений параметров через запятую
//    Значение по умолчанию: `"{Параметры}"`
//
// Пример:
//  // Значение первого параметра будет 1 а второго 2, представление теста будет: "Тест([1, 2])"
//  //
//  &ПараметризованныйТест("{ОтображаемоеИмя}({Параметры})")
//  &ИсточникЗначение(1)
//  Процедура Тест(ПараметрСЕдиницей, ПараметрНеопределенно) Экспорт
// 
//  // Больше примеров смотри в аннотациях источников значений параметров
//
&Аннотация("ПараметризованныйТест")
&ТестШаблон("ПоставщикКонтекстаПараметризованныйТест")
Процедура ПриСозданииОбъекта(Имя = "")
КонецПроцедуры
