// Аннотация определяет что метод является повторяемым тестом.
// Повторяемый тест будет выполнен несколько раз, по значению переданному в аннотацию
//
// Параметры:
//  Значение - Число  - Количество повторений
//  Имя      - Строка - Шаблон имени теста для каждого конкретного повтора.
//    Может содержать автоматически заменяемые шаблоны:
//      {ОтображаемоеИмя}   - По правилам аннотации `&ОтображаемоеИмя`
//      {ТекущееПовторение} - Текущее повторение теста
//      {ВсегоПовторений}   - Всего повторений теста
//    Значение по умолчанию: `"Повторение {ТекущееПовторение} из {ВсегоПовторений}"`
//
// Пример:
//  1.
// 
//  // Будут добавлено 3 вызова теста
//  &ПовторяемыйТест(3)
//  Процедура Тест() Экспорт
// 
//  2.
// 
//  // Будут добавлено 3 вызова теста с именами:
//  //   Тест №1
//  //   Тест №2
//  //   Тест №3
//  &ПовторяемыйТест(3, Имя = "{ОтображаемоеИмя} №{ТекущееПовторение}")
//  Процедура Тест() Экспорт
// 
//  3.
// 
//  // Будут добавлено 3 вызова теста с именами:
//  //   Я повторяемый тест №1
//  //   Я повторяемый тест №2
//  //   Я повторяемый тест №3
//	&ПовторяемыйТест(3, Имя = "{ОтображаемоеИмя} №{ТекущееПовторение}")
//	&ОтображаемоеИмя("Я повторяемый тест")
//  Процедура Тест() Экспорт
//
&Аннотация("ПовторяемыйТест")
&ТестШаблон("ПоставщикКонтекстаПовторяемыйТест")
Процедура ПриСозданииОбъекта(Значение, Имя = "")
КонецПроцедуры
